//
// Graphic LCD module "M014C9163SPI" control subroutine sample program
//

#include <avr/io.h>						// WinAVR library
#include <util/delay.h>					// 

#include "m014c9163spi.h"

// printf redirect
#include <stdio.h>						// libc
int zz_putchar(char c, FILE *stream) {
	char	buf[2];

	buf[0] = c;
	buf[1] = '\0';
	lcd_prString(buf);
	return 0;
}
FILE lcd_iob = FDEV_SETUP_STREAM(zz_putchar, NULL, _FDEV_SETUP_WRITE);


// MAIN
int main(void){

	//
	// Initialize
	//
	CLKPR = _BV(CLKPCE);				// Change internal Clock divide
	CLKPR = 0;							// 8MHz  Need project options "Frequency"
	lcd_open();							// LCD module setup
	stdout = &lcd_iob;					// printf redirect

	for(;;) {
		int 	i;

		//
		// Graphic figure
		//
		lcd_draw_rect(  0,  0, 129,129, LCD_COLOR_BLACK);			// Square box
		lcd_draw_line( 10,129,  65,  0, 1, LCD_COLOR_GREEN);		// Pentagram
		lcd_draw_line( 65,  0, 119,129, 1, LCD_COLOR_GREEN);
		lcd_draw_line(119,129,   0, 45, 1, LCD_COLOR_GREEN);
		lcd_draw_line(  0, 45, 129, 45, 1, LCD_COLOR_GREEN);
		lcd_draw_line(129, 45,  10,129, 1, LCD_COLOR_GREEN);
		lcd_draw_str(30, 60, LCD_COLOR_BLUE, LCD_COLOR_WHITE, "Hello world!!");

		// Wait
		_delay_ms(2000);

		//
		// Character Display function
		//
		lcd_control(LCD_DISP_CLEAR_HOME);
		lcd_prString("itendo M014C9163SPI");
		lcd_position(1, 2);						// Row Column
		lcd_prString("and Atmel ATmega328P");
		lcd_color(LCD_COLOR_ORANGE);
		lcd_position(0, 4);						// Row Column
		lcd_prString("ABCDEFGHIJKLM");
		lcd_position(0, 5);						// Row Column
		lcd_prString("NOPQRSTUVWXYZ");
		lcd_color(LCD_COLOR_WHITE);

		// Wait
		_delay_ms(2000);

		//
		// printf redirect
		//
		printf("\f");							// Clear Home
		for(i = 0; i < 15; i++) {
			printf("Text string %d...\n", i);
		}

		// Wait
		_delay_ms(2000);
	}

	return(0);
}
